# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetAccessControlPoliciesResult',
    'AwaitableGetAccessControlPoliciesResult',
    'get_access_control_policies',
    'get_access_control_policies_output',
]

@pulumi.output_type
class GetAccessControlPoliciesResult:
    """
    A collection of values returned by getAccessControlPolicies.
    """
    def __init__(__self__, api_version=None, entities=None, id=None, metadatas=None):
        if api_version and not isinstance(api_version, str):
            raise TypeError("Expected argument 'api_version' to be a str")
        pulumi.set(__self__, "api_version", api_version)
        if entities and not isinstance(entities, list):
            raise TypeError("Expected argument 'entities' to be a list")
        pulumi.set(__self__, "entities", entities)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if metadatas and not isinstance(metadatas, list):
            raise TypeError("Expected argument 'metadatas' to be a list")
        pulumi.set(__self__, "metadatas", metadatas)

    @property
    @pulumi.getter(name="apiVersion")
    def api_version(self) -> str:
        """
        The version of the API.
        """
        return pulumi.get(self, "api_version")

    @property
    @pulumi.getter
    def entities(self) -> Sequence['outputs.GetAccessControlPoliciesEntityResult']:
        """
        List of Access Control Policies
        """
        return pulumi.get(self, "entities")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def metadatas(self) -> Sequence['outputs.GetAccessControlPoliciesMetadataResult']:
        """
        - The Access Control Policy kind metadata.
        """
        return pulumi.get(self, "metadatas")


class AwaitableGetAccessControlPoliciesResult(GetAccessControlPoliciesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetAccessControlPoliciesResult(
            api_version=self.api_version,
            entities=self.entities,
            id=self.id,
            metadatas=self.metadatas)


def get_access_control_policies(metadatas: Optional[Sequence[Union['GetAccessControlPoliciesMetadataArgs', 'GetAccessControlPoliciesMetadataArgsDict']]] = None,
                                opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetAccessControlPoliciesResult:
    """
    Describes a list of access control policies.

    ## Example Usage


    :param Sequence[Union['GetAccessControlPoliciesMetadataArgs', 'GetAccessControlPoliciesMetadataArgsDict']] metadatas: - The Access Control Policy kind metadata.
    """
    __args__ = dict()
    __args__['metadatas'] = metadatas
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('nutanix:index/getAccessControlPolicies:getAccessControlPolicies', __args__, opts=opts, typ=GetAccessControlPoliciesResult).value

    return AwaitableGetAccessControlPoliciesResult(
        api_version=pulumi.get(__ret__, 'api_version'),
        entities=pulumi.get(__ret__, 'entities'),
        id=pulumi.get(__ret__, 'id'),
        metadatas=pulumi.get(__ret__, 'metadatas'))
def get_access_control_policies_output(metadatas: Optional[pulumi.Input[Optional[Sequence[Union['GetAccessControlPoliciesMetadataArgs', 'GetAccessControlPoliciesMetadataArgsDict']]]]] = None,
                                       opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetAccessControlPoliciesResult]:
    """
    Describes a list of access control policies.

    ## Example Usage


    :param Sequence[Union['GetAccessControlPoliciesMetadataArgs', 'GetAccessControlPoliciesMetadataArgsDict']] metadatas: - The Access Control Policy kind metadata.
    """
    __args__ = dict()
    __args__['metadatas'] = metadatas
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('nutanix:index/getAccessControlPolicies:getAccessControlPolicies', __args__, opts=opts, typ=GetAccessControlPoliciesResult)
    return __ret__.apply(lambda __response__: GetAccessControlPoliciesResult(
        api_version=pulumi.get(__response__, 'api_version'),
        entities=pulumi.get(__response__, 'entities'),
        id=pulumi.get(__response__, 'id'),
        metadatas=pulumi.get(__response__, 'metadatas')))
