# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs

__all__ = [
    'GetNdbNetworksResult',
    'AwaitableGetNdbNetworksResult',
    'get_ndb_networks',
    'get_ndb_networks_output',
]

@pulumi.output_type
class GetNdbNetworksResult:
    """
    A collection of values returned by getNdbNetworks.
    """
    def __init__(__self__, id=None, networks=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if networks and not isinstance(networks, list):
            raise TypeError("Expected argument 'networks' to be a list")
        pulumi.set(__self__, "networks", networks)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def networks(self) -> Sequence['outputs.GetNdbNetworksNetworkResult']:
        """
        List of networks in NDB
        """
        return pulumi.get(self, "networks")


class AwaitableGetNdbNetworksResult(GetNdbNetworksResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetNdbNetworksResult(
            id=self.id,
            networks=self.networks)


def get_ndb_networks(opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetNdbNetworksResult:
    """
    List of networks in Nutanix Database Service

    ## Example Usage

    ```python
    import pulumi
    import pulumi_nutanix as nutanix

    nw = nutanix.get_ndb_networks()
    ```
    """
    __args__ = dict()
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('nutanix:index/getNdbNetworks:getNdbNetworks', __args__, opts=opts, typ=GetNdbNetworksResult).value

    return AwaitableGetNdbNetworksResult(
        id=pulumi.get(__ret__, 'id'),
        networks=pulumi.get(__ret__, 'networks'))
def get_ndb_networks_output(opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetNdbNetworksResult]:
    """
    List of networks in Nutanix Database Service

    ## Example Usage

    ```python
    import pulumi
    import pulumi_nutanix as nutanix

    nw = nutanix.get_ndb_networks()
    ```
    """
    __args__ = dict()
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('nutanix:index/getNdbNetworks:getNdbNetworks', __args__, opts=opts, typ=GetNdbNetworksResult)
    return __ret__.apply(lambda __response__: GetNdbNetworksResult(
        id=pulumi.get(__response__, 'id'),
        networks=pulumi.get(__response__, 'networks')))
