# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetUsersResult',
    'AwaitableGetUsersResult',
    'get_users',
    'get_users_output',
]

@pulumi.output_type
class GetUsersResult:
    """
    A collection of values returned by getUsers.
    """
    def __init__(__self__, api_version=None, entities=None, id=None, metadatas=None):
        if api_version and not isinstance(api_version, str):
            raise TypeError("Expected argument 'api_version' to be a str")
        pulumi.set(__self__, "api_version", api_version)
        if entities and not isinstance(entities, list):
            raise TypeError("Expected argument 'entities' to be a list")
        pulumi.set(__self__, "entities", entities)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if metadatas and not isinstance(metadatas, list):
            raise TypeError("Expected argument 'metadatas' to be a list")
        pulumi.set(__self__, "metadatas", metadatas)

    @property
    @pulumi.getter(name="apiVersion")
    def api_version(self) -> str:
        """
        The version of the API.
        """
        return pulumi.get(self, "api_version")

    @property
    @pulumi.getter
    def entities(self) -> Sequence['outputs.GetUsersEntityResult']:
        """
        List of Users
        """
        return pulumi.get(self, "entities")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def metadatas(self) -> Sequence['outputs.GetUsersMetadataResult']:
        """
        - The user kind metadata.
        """
        return pulumi.get(self, "metadatas")


class AwaitableGetUsersResult(GetUsersResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetUsersResult(
            api_version=self.api_version,
            entities=self.entities,
            id=self.id,
            metadatas=self.metadatas)


def get_users(metadatas: Optional[Sequence[Union['GetUsersMetadataArgs', 'GetUsersMetadataArgsDict']]] = None,
              opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetUsersResult:
    """
    Provides a datasource to retrieve all the users.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_nutanix as nutanix

    user = nutanix.User("user", directory_service_user={
        "directory_service_reference": {
            "uuid": "<directory-service-uuid>",
        },
        "user_principal_name": "test-user@ntnxlab.local",
    })
    users = nutanix.get_user()
    ```


    :param Sequence[Union['GetUsersMetadataArgs', 'GetUsersMetadataArgsDict']] metadatas: - The user kind metadata.
    """
    __args__ = dict()
    __args__['metadatas'] = metadatas
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('nutanix:index/getUsers:getUsers', __args__, opts=opts, typ=GetUsersResult).value

    return AwaitableGetUsersResult(
        api_version=pulumi.get(__ret__, 'api_version'),
        entities=pulumi.get(__ret__, 'entities'),
        id=pulumi.get(__ret__, 'id'),
        metadatas=pulumi.get(__ret__, 'metadatas'))
def get_users_output(metadatas: Optional[pulumi.Input[Optional[Sequence[Union['GetUsersMetadataArgs', 'GetUsersMetadataArgsDict']]]]] = None,
                     opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetUsersResult]:
    """
    Provides a datasource to retrieve all the users.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_nutanix as nutanix

    user = nutanix.User("user", directory_service_user={
        "directory_service_reference": {
            "uuid": "<directory-service-uuid>",
        },
        "user_principal_name": "test-user@ntnxlab.local",
    })
    users = nutanix.get_user()
    ```


    :param Sequence[Union['GetUsersMetadataArgs', 'GetUsersMetadataArgsDict']] metadatas: - The user kind metadata.
    """
    __args__ = dict()
    __args__['metadatas'] = metadatas
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('nutanix:index/getUsers:getUsers', __args__, opts=opts, typ=GetUsersResult)
    return __ret__.apply(lambda __response__: GetUsersResult(
        api_version=pulumi.get(__response__, 'api_version'),
        entities=pulumi.get(__response__, 'entities'),
        id=pulumi.get(__response__, 'id'),
        metadatas=pulumi.get(__response__, 'metadatas')))
